capsule/urls.py
from django.urls import path
from .views import *

app_name = 'capsule'
urlpatterns = [
    #path('', index, name="welcome"),
    path('api', get_capsule_api, name="capsule_api"),
    path('', capsule_list, name="capsule_list"),
    path('detail/<str:id>', capsule_detail, name="capsule_detail"),
]

spacex/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('capsule.urls')),
]

capsule/models.py
from django.db import models
from utils.base_model import BaseModel
# Create your models here.


# https://github.com/r-spacex/SpaceX-API/blob/master/docs/capsules/v4/schema.md
class Capsule(BaseModel):

    STATUS_CHOICES = (
        ('unknown', 'Unknown'),
        ('active', 'Active'),
        ('retired', 'Retired'),
        ('destroyed', 'Destroyed'),
    )
    TYPE_CHOICES = (
        ('Dragon 1.0', 'Dragon 1.0'),
        ('Dragon 1.1', 'Dragon 1.1'),
        ('Dragon 2.0', 'Dragon 2.0'),
    )
    capsule_id = models.CharField(max_length=32, unique=True)
    reuse_count = models.PositiveIntegerField(default=0)
    water_landings = models.PositiveIntegerField(default=0)
    land_landings = models.PositiveIntegerField(default=0)
    last_update = models.CharField(max_length=255, blank=True, null=True)
    serial = models.CharField(max_length=8, unique=True)
    status = models.CharField(choices=STATUS_CHOICES, max_length=16, default='unknown')
    type = models.CharField(choices=TYPE_CHOICES, max_length=16, default='Dragon 1.0')

    def __str__(self):
        return self.capsule_id

    #Liste launches by capsule
    def launches(self):
        queryset = self.launche_set.all()
        return queryset if queryset else None


# https://github.com/r-spacex/SpaceX-API/blob/master/docs/launches/v4/schema.md
class Launche(BaseModel):
    launche_id = models.CharField(max_length=32, unique=True)
    success = models.BooleanField()
    upcoming = models.BooleanField(default=False)
    name = models.CharField(max_length=255)
    flight_number = models.PositiveSmallIntegerField(default=1)
    details = models.TextField(blank=True, null=True)
    static_fire_date_utc = models.CharField(max_length=255, blank=True, null=True)
    link_patch_image = models.URLField()
    link_patch_webcast = models.URLField()
    capsule = models.ForeignKey(Capsule, on_delete=models.CASCADE)

    def __str__(self):
        return self.launche_id

capsule/views.py
from django.shortcuts import redirect, render
from .models import *
from services.spacex_service import SpaceXService
from utils.custom_functions import find, find_all, save_instance
from django.contrib import messages
#import spacexpy


# ---------------- Get capsules by API  -----------------
def get_capsule_api(request):

    #spacex = spacexpy.SpaceX()
    #cl = spacex.capsules()
    #print(cl)
    # Spacex Api params
    end_point = 'capsules'
    params = {}
    spacex = SpaceXService()
    # Get list of capsules
    capsules = spacex.get_full_data_request(end_point, params)

    responseJson = capsules.json()
    if responseJson:
        for caps in responseJson:

            # Check if capsules exist before save in Sqlite
            capsule = find(Capsule, {'capsule_id': caps['id']})
            if(capsule is None):
                # save capsule
                capsule = save_instance(Capsule, {
                    'capsule_id': caps['id'],
                    'reuse_count': caps['reuse_count'],
                    'water_landings': caps['water_landings'],
                    'land_landings': caps['land_landings'],
                    'last_update': caps['last_update'],
                    'serial': caps['serial'],
                    'status': caps['status'],
                    'type': caps['type']
                })
                
            # Find all launches of this capsule
            for launche_id in caps['launches']:
                # Get list of launches by cupsule
                end_point_launche = 'launches/'+launche_id
                launches = spacex.get_full_data_request(end_point_launche, params)

                launcheJson = launches.json()
                if launcheJson:

                    # Check if launches exist before save in Sqlite
                    launche = find(Launche, {'launche_id': launche_id})
                    if(launche is None):
                        # save launche
                        save_instance(Launche, {
                            'launche_id': launche_id,
                            'success': bool(launcheJson['success']),
                            'upcoming': bool(launcheJson['upcoming']),
                            'name': launcheJson['name'],
                            'flight_number': launcheJson['flight_number'],
                            'details': launcheJson['details'],
                            'static_fire_date_utc': launcheJson['static_fire_date_utc'],
                            'link_patch_image': launcheJson['links']['patch']['small'],
                            'link_patch_webcast': launcheJson['links']['webcast'],
                            'capsule': capsule
                        })
        
        messages.success(request, "Recuperation des capsules réalisée avec succès.")

    template_name = "capsule/index.html"
    context = {
        'page': {
            'title': 'Capsule',
            'name': 'Capsule'
        },
        'charge_active': True,
        'capsules': capsules
    }
    return render(request, template_name, context)


# ---------------- Get capsules list  -----------------
def capsule_list(request):

    template_name = "capsule/list.html"
    capsules = find_all(Capsule, {}) # get capsule liste
    context = {
        'page': {
            'title': 'Liste des capsule',
            'name': 'Capsule'
        },
        'list_active': True,
        'capsules': capsules
    }
    return render(request, template_name, context)


# ---------------- Get detail capsules  -----------------
def capsule_detail(request, id):

    # Find capsule or put error message and redirect
    capsule = find(Capsule, {'capsule_id': id})
    if capsule is None:
        messages.error(request, "Capsule introuvable.")
        return redirect ('capsule:capsule_list') 

    template_name = "capsule/detail.html"
    context = {
        'page': {
            'title': 'Detail capsule',
            'name': 'Detail capsule'
        },
        'list_active': True,
        'capsule': capsule
    }
    return render(request, template_name, context)

capsule/templates/capsule/base.html
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>SpaceX Api</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KK94CHFLLe+nY2dmCWGMq91rCGa5gtU4mk92HdvYe+M/SXH301p5ILy+dN9+nJOZ" crossorigin="anonymous">
  </head>
  <body>
    <main>
        <div class="container">
            <header class="d-flex flex-wrap justify-content-center py-3 mb-4 border-bottom">
                <a href="/" class="d-flex align-items-center mb-3 mb-md-0 me-md-auto link-body-emphasis text-decoration-none">
                    <svg class="bi me-2" width="40" height="32"><use xlink:href="#bootstrap"/></svg>
                    <span class="fs-4">SpaceX</span>
                </a>

                <ul class="nav nav-pills">
                    <li class="nav-item"><a href="{% url 'capsule:capsule_list' %}" class="nav-link {% if list_active %}active{% endif %}">Liste des capsules</a></li>
                    <li class="nav-item"><a href="{% url 'capsule:capsule_api' %}" class="nav-link {% if charge_active %}active{% endif %}">Charger les capsules</a></li>
                </ul>
            </header>
            {% include 'capsule/info_message.html' %}
        </div>
        <div class="b-example-divider"></div>

        {% block content %}
        
        {% endblock %}

    </main>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ENjdO4Dr2bkBIFxQpeoTz1HIcje39Wm4jDKdf19U8gI4ddQ3GYNS7NTKfAdVQSZe" crossorigin="anonymous"></script>
  </body>

capsule/templates/capsule/detail.html
{% extends 'capsule/base.html' %}

{% block content %} 
    <div class="container">
        
        <div class="row g-5">
            <div class="col-md-8">
                <h3 class="pb-4 mb-4 fst-italic border-bottom">
                    Detail de la capsule
                </h3>

                {% for launch in capsule.launches %}
                    <article class="blog-post">
                        <h2 class="blog-post-title mb-1">Lancement - {{launch.name}}</h2>
                        <p class="blog-post-meta text-right">{{launch.static_fire_date_utc}}</p>
                        <div class="p-4 mb-3 bg-body-tertiary rounded">
                            <h4 class="fst-italic">Detail</h4>
                            <p class="mb-0">{{launch.details|safe}}</p>
                        </div>
                    </article>
                    <nav class="blog-pagination" aria-label="Pagination">
                        <a class="mr-5" href="{{launch.link_patch_webcast}}" target="_blank">Youtube</a>
                        <button class="ml-5 btn btn{% if launch.success %}-success {% else %} disabled{% endif %} rounded-pill"> success </button>
                        <button class="btn btn{% if launch.upcoming %}-success {% else %} disabled{% endif %} rounded-pill"> upcoming </button>
                    </nav>
                    <div class="mt-2 text-center">
                        <img src="{{launch.link_patch_image}}" alt="image">
                    </div>
                {% empty %}
                    <div class="p-4 mb-3 bg-body-tertiary rounded">
                        <h4 class="fst-italic">Aucun launche trouvé</h4>
                    </div>
                {% endfor %}

                
            </div>

            <div class="col-md-4">
                <div class="position-sticky" style="top: 2rem;">

                    <div class="p-4">
                        <h4 class="fst-italic">Capsule</h4>
                        <ol class="list-unstyled">
                            <li>Land landings: {{capsule.land_landings}}</li>
                            <li>Water landings: {{capsule.water_landings}}</li>
                            <li>Reuse count: {{capsule.reuse_count}}</li>
                            <li>Serial: <b>{{capsule.serial}}</b></li>
                        </ol>
                    </div>

                    <div class="p-4 mb-3 bg-body-tertiary rounded">
                        <h4 class="fst-italic">Statut</h4>
                        <p class="mb-0">{{capsule.status}}</p>
                    </div>
                    <div class="p-4 mb-3 bg-body-tertiary rounded">
                        <h4 class="fst-italic">Type</h4>
                        <p class="mb-0">{{capsule.type}}</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

capsule/templates/capsule/index.html
{% extends 'capsule/base.html' %}

{% block content %} 
{% endblock %}

capsule/templates/capsule/info_message.html
{% for message in messages %}
  <div class="row">
    <div class="col-12 ">
      <div class="alert alert-{% if message.tags == 'error' %}danger {% else %}{{message.tags}} {% endif %} alert-dismissible fade show" role="alert" style="font-size: 16px; text-align: center;">
        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        {{ message }}
      </div>
    </div>
  </div>
{% endfor %}

capsule/templates/capsule/list.html
{% extends 'capsule/base.html' %}

{% block content %} 
    <div class="container">
        <h3 class="mt-5 mb-5">Liste des capsules ({{capsules.count}})</h3>
        <table class="table">
            <thead>
                <tr>
                    <th>#</th>
                    <th>Serial</th>
                    <th>Status</th>
                    <th>Type</th>
                    <th>Water landings</th>
                    <th>Land landings</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                {% for capsule in capsules %}
                    <tr>
                        <td>{{forloop.counter}}</td>
                        <td>{{capsule.serial}}</td>
                        <td>{{capsule.status}}</td>
                        <td>{{capsule.type}}</td>
                        <td>{{capsule.water_landings}}</td>
                        <td>{{capsule.land_landings}}</td>
                        <td><a class="btn btn-success btn-sm" href="{% url 'capsule:capsule_detail' capsule.capsule_id %}">Voir plus</a></td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
{% endblock %}